#!/bin/sh

function all_part_includes {
  all_parts=`perl -I../tools/lib -MDemo::Config -e "$, = ' '; print Demo::Config->new(config_file => 'config.yml')->part_names();"`
  echo $all_parts | sed -e 's/\b\([0-9]\+-\([a-z0-9-]\+\)\)\b/\1\/\2.inc/gi'
}

function all_part_names {
  all_parts=`perl -Itools/lib -MDemo::Config -e "$, = ' '; print Demo::Config->new(config_file => 'src/config.yml')->part_names();"`
  echo $all_parts | sed -e 's/^\|\s\b/ src\//g'
}

function all_part_name_dirs {
  all_parts=`perl -I../tools/lib -MDemo::Config -e "$, = ' '; print Demo::Config->new(config_file => 'config.yml')->part_names();"`
  echo $all_parts
}

function part_file_name {
  part_name=`pwd | sed -e 's/^.*\///'`
  cat ../target/part-names.cfg | grep ${part_name} | awk -F'=' '{ print $2 }' | sed -e 's/^ //'
}

function loading_address {
  part_name=`pwd | sed -e 's/^.*\///'`
  perl -I../../tools/lib -MDemo::Config -e "print Demo::Config->new()->loading_address('$part_name')"
}

function start_address {
  part_name=`pwd | sed -e 's/^.*\///' | sed -e 's/^[0-9]\+-//'`
  part_name_uc=`echo ${part_name} | awk '{ print toupper($0) }' | sed -e 's/-/_/g'`
  start_address_line=`cat ${part_name}.inc | grep -e "${part_name_uc}_START_ADDRESS\s*="`
  echo $start_address_line | awk -F' ' '{ print $3 }' | sed -e 's/^\$//'
}
