;-------------------------------
irq_welcome_0   lda #$00
                sta $d011
                lda #$01
                sta $d020
                sta $d021

                jsr msx_play_exec

                inc irq_counter
                lda irq_counter
                cmp #DELAY_BEFORE_WELCOME
                beq *+9

                ldx #<irq_welcome_0
                ldy #>irq_welcome_0
                lda #$00
                rts

                ldx #<irq_welcome_1
                ldy #>irq_welcome_1
                lda #$00
                rts
;-------------------------------
irq_welcome_1   lda #$00
                sta $d011
                lda #TEXT_COLOUR
                sta $d020
                sta $d021

                jsr msx_play_exec

                ldx #$00
                lda WELCOME_TO_SCREEN_DATA,x
                sta WELCOME_TO_SCREEN_VIEW,x
                inx
                cpx #($28 * $05)
                bne *-9

                lda #$00
                sta irq_counter

                ldx #<irq_welcome_2
                ldy #>irq_welcome_2
                lda #$00
                rts
;-------------------------------
irq_welcome_2   ldx irq_counter
                lda irq_flash_colours,x
                sta $d020
                sta $d021

                jsr welcome_to_vic_setup

                jsr msx_play_exec

                inc irq_counter
                lda irq_counter
                cmp #IRQ_FLASH_COLOURS_COUNT
                beq *+9

                ldx #<irq_welcome_2
                ldy #>irq_welcome_2
                lda #$00
                rts

                lda #$00
                sta irq_counter

                ldx #<irq_welcome_3
                ldy #>irq_welcome_3
                lda #$00
                rts
;-------------------------------
irq_welcome_3   jsr welcome_to_vic_setup

                jsr msx_play_exec

                inc irq_counter
                lda irq_counter
                cmp #DELAY_BETWEEN_WELCOME_AND_TO
                beq *+9

                ldx #<irq_welcome_3
                ldy #>irq_welcome_3
                lda #$00
                rts

                ldx #<irq_welcome_4
                ldy #>irq_welcome_4
                lda #$00
                rts
;-------------------------------
irq_welcome_4   lda #$00
                sta $d011
                lda #TEXT_COLOUR
                sta $d020
                sta $d021

                jsr msx_play_exec

                ldx #$00
                lda WELCOME_TO_SCREEN_DATA + $0118,x
                sta WELCOME_TO_SCREEN_VIEW + $0118,x
                inx
                cpx #($28 * $04)
                bne *-9

                lda #$00
                sta irq_counter

                ldx #<irq_welcome_5
                ldy #>irq_welcome_5
                lda #$00
                rts
;-------------------------------
irq_welcome_5   ldx irq_counter
                lda irq_flash_colours,x
                sta $d020
                sta $d021

                jsr welcome_to_vic_setup

                jsr msx_play_exec

                inc irq_counter
                lda irq_counter
                cmp #IRQ_FLASH_COLOURS_COUNT
                beq *+9

                ldx #<irq_welcome_5
                ldy #>irq_welcome_5
                lda #$00
                rts

                lda #$00
                sta irq_counter

                ldx #<irq_welcome_6
                ldy #>irq_welcome_6
                lda #$00
                rts
;-------------------------------
irq_welcome_6   jsr welcome_to_vic_setup

                jsr msx_play_exec

                inc irq_counter
                lda irq_counter
                cmp #DELAY_BETWEEN_WELCOME_AND_TO
                beq *+9

                ldx #<irq_welcome_6
                ldy #>irq_welcome_6
                lda #$00
                rts

                lda #$00
                sta irq_counter

                ldx #<irq_welcome_7
                ldy #>irq_welcome_7
                lda #$00
                rts
;-------------------------------
irq_welcome_7   jsr welcome_to_vic_setup

                jsr msx_play_exec

                ldx #<irq_soci_1
                ldy #>irq_soci_1
                lda #RASTER_LINE_SOCI
                rts
;-------------------------------
irq_welcome_8   jsr welcome_to_vic_setup

                ldx irq_counter
                lda zatrzesienie_d016,x
                sta $d016

                jsr msx_play_exec

                ldx #<irq_soci_2
                ldy #>irq_soci_2
                lda #RASTER_LINE_SOCI
                rts
;-------------------------------
irq_welcome_9   jsr welcome_to_vic_setup

                jsr msx_play_exec

                ldx #<irq_soci_3
                ldy #>irq_soci_3
                lda #RASTER_LINE_SOCI
                rts
;-------------------------------
; IRQ upper part ("Welcome to") during flashing out of "SOCI" -> "SUCA" switch:
irq_welcome_10  ldx irq_counter
                lda irq_flash_colours,x
                sta $d020
                sta $d021

                jsr welcome_to_vic_setup

                jsr msx_play_exec

                inc irq_counter
                lda irq_counter
                cmp #IRQ_FLASH_COLOURS_COUNT
                beq *+9

                ldx #<irq_suca_1
                ldy #>irq_suca_1
                lda #RASTER_LINE_SOCI
                rts

                lda #$00
                sta irq_counter

                ldx #<irq_suca_2
                ldy #>irq_suca_2
                lda #RASTER_LINE_SOCI
                rts
;-------------------------------
; IRQ upper part ("Welcome to") during display of "Welcome to SUCA" text:
irq_welcome_11  jsr welcome_to_vic_setup

                jsr msx_play_exec

                ldx #<irq_suca_2
                ldy #>irq_suca_2
                lda #RASTER_LINE_SOCI
                rts
;-------------------------------
; IRQ upper part ("Welcome to") during up-scrolling of "HORNA" text:
irq_welcome_12  jsr welcome_to_vic_setup

                jsr msx_play_exec

                ldx #<irq_horna_1
                ldy #>irq_horna_1
                lda #RASTER_LINE_BETWEN_HORNA_AND_SOCI
                rts
;-------------------------------
; IRQ upper part ("Welcome to HORNA") after completed scroll up of "HORNA" text:
irq_welcome_13  jsr welcome_to_vic_setup

                jsr msx_play_exec

                ldx #<irq_horna_2
                ldy #>irq_horna_2
                lda #RASTER_LINE_BETWEN_HORNA_AND_SOCI
                rts
;-------------------------------
; IRQ upper part ("Welcome to HORNA") during stamping "2014" sign:
irq_welcome_14  jsr welcome_to_vic_setup

                ldx irq_counter
                lda zatrzesienie_d016,x
                sta $d016

                jsr sprites_2014_positions_stamped

                jsr msx_play_exec

                ldx #<irq_stamp_1
                ldy #>irq_stamp_1
                lda #(RASTER_LINE_BETWEN_HORNA_AND_SOCI - 3)
                rts
;-------------------------------
; IRQ upper part ("Welcome to HORNA") after stamping "2014" sign completed:
irq_welcome_15  jsr welcome_to_vic_setup

                jsr msx_play_exec

                ldx #<irq_stamp_2
                ldy #>irq_stamp_2
                lda #(RASTER_LINE_BETWEN_HORNA_AND_SOCI - 3)
                rts
;-------------------------------
irq_flash_colours .db TEXT_COLOUR,$02,$02,$0a,$0a,$0f,$0f,$01
IRQ_FLASH_COLOURS_COUNT = *-irq_flash_colours
;-------------------------------

;-------------------------------
irq_counter     .db $00
;-------------------------------
