;-------------------------------
; IRQ upper part ("Welcome to") during blinking of question mark sprites:
irq_question_top_1

                jsr welcome_to_vic_setup

                jsr sprites_question_mark_positions

                jsr sprites_question_mark_colours

                jsr sprites_question_mark_setup

                jsr msx_play_exec

                ldx #<irq_question_bottom_1
                ldy #>irq_question_bottom_1
                lda #RASTER_LINE_SOCI
                rts
;-------------------------------
; IRQ upper part ("Welcome to") after blinking question mark sprites disappeared:
irq_question_top_2

                jsr welcome_to_vic_setup

                jsr msx_play_exec

                ldx #<irq_question_bottom_2
                ldy #>irq_question_bottom_2
                lda #RASTER_LINE_SOCI
                rts
;-------------------------------
; IRQ bottom part ("SOCI") during blinking of question mark sprites:
; .align $100
irq_question_bottom_1

                ; .stabilize_raster_v2(RASTER_LINE_SOCI)

                jsr soci_wjazd_vic_setup

                inc irq_counter
                lda irq_counter
                cmp #DELAY_BEFORE_QUESTION_MARK_DISAPPERS
                beq *+9

                ldx #<irq_question_top_1
                ldy #>irq_question_top_1
                lda #$00
                rts

                lda #$00
                sta irq_counter
                sta $d015

                ldx #<irq_question_top_2
                ldy #>irq_question_top_2
                lda #$00
                rts
;-------------------------------
; IRQ bottom part ("SOCI") after blinking question mark sprites disappeared:
; .align $100
irq_question_bottom_2

                ; .stabilize_raster_v2(RASTER_LINE_SOCI)

                jsr soci_wjazd_vic_setup

                inc irq_counter
                lda irq_counter
                cmp #DELAY_BETWEEN_SOCI_AND_SUCA
                beq *+9

                ldx #<irq_question_top_2
                ldy #>irq_question_top_2
                lda #$00
                rts

                lda #$00
                sta irq_counter

                ldx #<irq_welcome_10
                ldy #>irq_welcome_10
                lda #$00
                rts
;-------------------------------
sprites_question_mark_positions

                ; 1. Calculate new positions from a sinus lookup table:
                lda irq_counter
                and #$01
                beq *+5
                inc sprites_move_position_y

                ; 2. Write X/Y positions into appropriate VIC registers:
                lda irq_counter
                clc
                adc #$30
                and #$7f
                tax
                lda question_mark_sinus,x
                clc
                adc #$12

                sta $d000
                sta $d004
                sta $d008
                clc
                adc #$18
                sta $d002
                sta $d006
                sta $d00a

                lda sprites_move_position_y
                sta $d001
                sta $d003
                clc
                adc #$15
                sta $d005
                sta $d007
                clc
                adc #$15
                sta $d009
                sta $d00b

                lda #%00111111
                sta $d010

                rts
;-------------------------------
sprites_question_mark_colours

                ; 1. Calculate new colour from a lookup table:
                lda irq_counter
                lsr
                and #$1f
                tax

                ; 2. Write new colour into appropriate VIC registers:
                lda sprites_flashing_colours,x
                sta $d027   ; sprite 0 color
                sta $d028   ; sprite 1 color
                sta $d029   ; sprite 2 color
                sta $d02a   ; sprite 3 color
                sta $d02b   ; sprite 4 color
                sta $d02c   ; sprite 5 color

                rts
;-------------------------------
sprites_flashing_colours .db $0f,$0a,$08,$09,$02,$02,$02,$02
                         .db $02,$02,$02,$02,$09,$08,$0a,$0f
                         .db $01,$01,$01,$01,$01,$01,$01,$01
                         .db $01,$01,$01,$01,$01,$01,$01,$01
;-------------------------------
sprites_question_mark_setup

                lda #SPRITE_Q_0_SCREEN_VALUE
                sta SOCI_WJAZD_SCREEN_VIEW + $03f8 ; sprite 0 memory data
                sta WELCOME_TO_SCREEN_VIEW + $03f8 ; sprite 0 memory data
                lda #SPRITE_Q_1_SCREEN_VALUE
                sta SOCI_WJAZD_SCREEN_VIEW + $03f9 ; sprite 1 memory data
                sta WELCOME_TO_SCREEN_VIEW + $03f9 ; sprite 1 memory data
                lda #SPRITE_Q_2_SCREEN_VALUE
                sta SOCI_WJAZD_SCREEN_VIEW + $03fa ; sprite 2 memory data
                sta WELCOME_TO_SCREEN_VIEW + $03fa ; sprite 2 memory data
                lda #SPRITE_Q_3_SCREEN_VALUE
                sta SOCI_WJAZD_SCREEN_VIEW + $03fb ; sprite 3 memory data
                sta WELCOME_TO_SCREEN_VIEW + $03fb ; sprite 3 memory data
                lda #SPRITE_Q_4_SCREEN_VALUE
                sta SOCI_WJAZD_SCREEN_VIEW + $03fc ; sprite 4 memory data
                sta WELCOME_TO_SCREEN_VIEW + $03fc ; sprite 4 memory data
                lda #SPRITE_Q_5_SCREEN_VALUE
                sta SOCI_WJAZD_SCREEN_VIEW + $03fd ; sprite 5 memory data
                sta WELCOME_TO_SCREEN_VIEW + $03fd ; sprite 5 memory data
                lda #$00
                sta $d01c   ; sprites multi-color mode select
                lda #$00
                sta $d017   ; expand sprites 2x vertical (Y)
                sta $d01d   ; expand sprites 2x horizontal (X)
                lda #$00
                sta $d01b   ; sprite is in front of the graphics
                lda #$3f
                sta $d015   ; make them visible

                rts
;-------------------------------
question_mark_sinus
#include "target/question-mark-sinus-table.inc"
;-------------------------------
