;-------------------------------
; IRQ upper part ("Welcome to") during blinking of exclamation mark sprites:
irq_exclamation_top_1

                jsr welcome_to_vic_setup

                jsr sprites_exclamation_mark_positions

                jsr sprites_exclamation_mark_colours

                jsr sprites_exclamation_mark_setup

                jsr msx_play_exec

                ldx #<irq_exclamation_bottom_1
                ldy #>irq_exclamation_bottom_1
                lda #RASTER_LINE_SOCI
                rts
;-------------------------------
; IRQ upper part ("Welcome to") after blinking exclamation mark sprites disappeared:
irq_exclamation_top_2

                jsr welcome_to_vic_setup

                jsr msx_play_exec

                ldx #<irq_exclamation_bottom_2
                ldy #>irq_exclamation_bottom_2
                lda #RASTER_LINE_SOCI
                rts
;-------------------------------
; IRQ bottom part ("SUCA") during blinking of exclamation mark sprites:
; .align $100
irq_exclamation_bottom_1

                ; .stabilize_raster_v2(RASTER_LINE_SOCI)

                jsr suca_wjazd_vic_setup

                inc irq_counter
                lda irq_counter
                cmp #DELAY_BEFORE_EXCLAMATION_MARK_DISAPPEARS
                beq *+9

                ldx #<irq_exclamation_top_1
                ldy #>irq_exclamation_top_1
                lda #$00
                rts

                lda #$00
                sta irq_counter
                sta $d015

                ldx #<irq_exclamation_top_2
                ldy #>irq_exclamation_top_2
                lda #$00
                rts
;-------------------------------
; IRQ bottom part ("SUCA") after blinking exclamation mark sprites disappeared:
; .align $100
irq_exclamation_bottom_2

                ; .stabilize_raster_v2(RASTER_LINE_SOCI)

                jsr suca_wjazd_vic_setup

                inc irq_counter
                lda irq_counter
                cmp #DELAY_BEFORE_HORNA_WJAZD
                beq *+9

                ldx #<irq_exclamation_top_2
                ldy #>irq_exclamation_top_2
                lda #$00
                rts

                lda #$00
                sta irq_counter

                ; Initialize "HORNA" up-scroller:
                jsr init_horna_wjazd

                ldx #<irq_welcome_12
                ldy #>irq_welcome_12
                lda #$00
                rts
;-------------------------------
sprites_exclamation_mark_positions

                ; 1. Calculate new positions from a sinus lookup table:
                dec sprites_move_position_y
                dec sprites_move_position_y

                ; 2. Write X/Y positions into appropriate VIC registers:
                lda irq_counter
                and #$3f
                tax
                lda exclamation_mark_sinus,x
                clc
                adc #$16

                sta $d000
                sta $d004
                sta $d008
                clc
                adc #$18
                sta $d002
                sta $d006
                sta $d00a

                lda sprites_move_position_y
                sta $d001
                sta $d003
                clc
                adc #$15
                sta $d005
                sta $d007
                clc
                adc #$15
                sta $d009
                sta $d00b

                lda #%00111111
                sta $d010

                rts
;-------------------------------
sprites_exclamation_mark_colours

                ; 1. Calculate new colour from a lookup table:
                lda irq_counter
                lsr
                and #$1f
                tax

                ; 2. Write new colour into appropriate VIC registers:
                lda sprites_flashing_colours_2,x
                sta $d027   ; sprite 0 color
                sta $d028   ; sprite 1 color
                sta $d029   ; sprite 2 color
                sta $d02a   ; sprite 3 color
                sta $d02b   ; sprite 4 color
                sta $d02c   ; sprite 5 color

                rts
;-------------------------------
sprites_flashing_colours_2 .db $0f,$0a,$08,$09,$02,$02,$02,$02
                           .db $02,$02,$02,$02,$02,$02,$02,$02
                           .db $02,$02,$02,$02,$02,$02,$02,$02
                           .db $09,$08,$0a,$0f,$01,$01,$01,$01
;-------------------------------
sprites_exclamation_mark_setup

                lda #SPRITE_E_0_SCREEN_VALUE
                sta SUCA_WJAZD_SCREEN_VIEW + $03f8 ; sprite 0 memory data
                sta WELCOME_TO_SCREEN_VIEW + $03f8 ; sprite 0 memory data
                lda #SPRITE_E_1_SCREEN_VALUE
                sta SUCA_WJAZD_SCREEN_VIEW + $03f9 ; sprite 1 memory data
                sta WELCOME_TO_SCREEN_VIEW + $03f9 ; sprite 1 memory data
                lda #SPRITE_E_2_SCREEN_VALUE
                sta SUCA_WJAZD_SCREEN_VIEW + $03fa ; sprite 2 memory data
                sta WELCOME_TO_SCREEN_VIEW + $03fa ; sprite 2 memory data
                lda #SPRITE_E_3_SCREEN_VALUE
                sta SUCA_WJAZD_SCREEN_VIEW + $03fb ; sprite 3 memory data
                sta WELCOME_TO_SCREEN_VIEW + $03fb ; sprite 3 memory data
                lda #SPRITE_E_4_SCREEN_VALUE
                sta SUCA_WJAZD_SCREEN_VIEW + $03fc ; sprite 4 memory data
                sta WELCOME_TO_SCREEN_VIEW + $03fc ; sprite 4 memory data
                lda #SPRITE_E_5_SCREEN_VALUE
                sta SUCA_WJAZD_SCREEN_VIEW + $03fd ; sprite 5 memory data
                sta WELCOME_TO_SCREEN_VIEW + $03fd ; sprite 5 memory data
                lda #$00
                sta $d01c   ; sprites multi-color mode select
                lda #$00
                sta $d017   ; expand sprites 2x vertical (Y)
                sta $d01d   ; expand sprites 2x horizontal (X)
                lda #$00
                sta $d01b   ; sprite is in front of the graphics
                lda #$3f
                sta $d015   ; make them visible

                rts
;-------------------------------
exclamation_mark_sinus
#include "target/exclamation-mark-sinus-table.inc"
;-------------------------------
