;-------------------------------
init_horna_wjazd

                ; Write all target but still empty characters into the current screen:
                ldy #$00
                ldx #$0e
                lda horna_wjazd_target_map + $0b * $00,y
                sta HORNA_WJAZD_SCREEN_VIEW + $28 * $00,x
                lda horna_wjazd_target_map + $0b * $01,y
                sta HORNA_WJAZD_SCREEN_VIEW + $28 * $01,x
                lda horna_wjazd_target_map + $0b * $02,y
                sta HORNA_WJAZD_SCREEN_VIEW + $28 * $02,x
                inx
                iny
                cpy #$0b
                bne *-4-6*3

                rts
;-------------------------------
horna_wjazd_target_map .db $c0,$c3,$c6,$c9,$cc,$cf,$d2,$d5,$d8,$db,$de
                       .db $c1,$c4,$c7,$ca,$cd,$d0,$d3,$d6,$d9,$dc,$df
                       .db $c2,$c5,$c8,$cb,$ce,$d1,$d4,$d7,$da,$dd,$e0
;-------------------------------
; IRQ bottom part ("SUCA") during up-scrolling of "HORNA" text:
; .align $100
irq_horna_1     ; .stabilize_raster_v2(RASTER_LINE_SOCI)

                jsr suca_wjazd_vic_setup

                ; Trigger "HORNA" text scroll up only every 4th frame:
                lda irq_counter
                and #$03
                bne *+8
                jsr scroll_up_horna_text
                jsr place_new_horna_line

                inc irq_counter
                lda irq_counter
                cmp #DELAY_HORNA_WJAZD_COMPLETED
                beq irq_horna_1_end

                ldx #<irq_welcome_12
                ldy #>irq_welcome_12
                lda #$00
                rts

irq_horna_1_end lda #$00
                sta irq_counter

                ldx #<irq_welcome_13
                ldy #>irq_welcome_13
                lda #$00
                rts
;-------------------------------
; IRQ bottom part ("SUCA") after completed scroll up of "HORNA" text:
; .align $100
irq_horna_2     ; .stabilize_raster_v2(RASTER_LINE_SOCI)

                jsr suca_wjazd_vic_setup

                inc irq_counter
                lda irq_counter
                cmp #DELAY_BEFORE_2014_STAMP
                beq *+9

                ldx #<irq_welcome_13
                ldy #>irq_welcome_13
                lda #$00
                rts

                lda #$00
                sta irq_counter

                ldx #<irq_welcome_14
                ldy #>irq_welcome_14
                lda #$00
                rts
;-------------------------------
scroll_up_horna_text

                ; Setup vector to shifted fonts data:
                lda #<HORNA_WJAZD_TARGET_FONTS
                sta Z1 + $00
                lda #>HORNA_WJAZD_TARGET_FONTS
                sta Z1 + $01

                ; Scroll up all 10 columns of 3 fonts data each:
                ldx #$00
_scr001         ldy #$00
_scr002         iny
                lda (Z1),y
                dey
                sta (Z1),y
                iny
                cpy #$17
                bne _scr002
                clc
                lda Z1 + $00
                adc #$18
                sta Z1 + $00
                bcc *+4
                inc Z1 + $01
                inx
                cpx #$0b
                bne _scr001

                rts
;-------------------------------
place_new_horna_line

                ; Set vector pointing to visible font to write data into it:
                lda #<(WELCOME_TO_CHARSET_DATA + $c2 * $08 + $07)
                sta Z3 + $00
                lda #>(WELCOME_TO_CHARSET_DATA + $c2 * $08 + $07)
                sta Z3 + $01

                ; Calculate real index step (0..7):
                lda irq_counter
                lsr
                lsr
                and #$07
                sta real_index_step

                ; Get source screen map data:
                lda irq_counter
                lsr
                lsr
                lsr
                lsr
                lsr
                tax
                lda horna_line_source_map_lo,x
                sta Z1 + $00
                lda horna_line_source_map_hi,x
                sta Z1 + $01

                ; Iterate through all 10 source fonts found on a screen map:
                lda #$00
                sta loop_iterator

_pla001         ; Get next font from a source screen map:
                ldy loop_iterator
                lda (Z1),y

                ; Get font data address for this font (multiply number by 8):
                asl
                asl
                asl
                sta Z2 + $00
                lda #>HORNA_WJAZD_CHARSET_DATA
                sta Z2 + $01

                ; Pick font's pixel row data from the real step index and place
                ; it onto a target screen (currently iterated position):
                ldy real_index_step
                lda (Z2),y
                ldy #$00
                sta (Z3),y

                ; Move vector pointing to visible font to the next column data:
                clc
                lda Z3 + $00
                adc #$18
                sta Z3 + $00
                bcc *+4
                inc Z3 + $01

                inc loop_iterator
                lda loop_iterator
                cmp #$0b
                bne _pla001

                rts
;-------------------------------
real_index_step .db $00
loop_iterator   .db $00
;-------------------------------
horna_line_source_map_lo .db <(HORNA_WJAZD_SCREEN_DATA + $28 * 00 + $0e)
                         .db <(HORNA_WJAZD_SCREEN_DATA + $28 * 01 + $0e)
                         .db <(HORNA_WJAZD_SCREEN_DATA + $28 * 02 + $0e)
;-------------------------------
horna_line_source_map_hi .db >(HORNA_WJAZD_SCREEN_DATA + $28 * 00 + $0e)
                         .db >(HORNA_WJAZD_SCREEN_DATA + $28 * 01 + $0e)
                         .db >(HORNA_WJAZD_SCREEN_DATA + $28 * 02 + $0e)
;-------------------------------
