;-------------------------------
; IRQ bottom part ("SUCA") during stamping "2014" sign:
; .align $100
irq_stamp_1     ; .stabilize_raster_v2(RASTER_LINE_SOCI)

                .stabilize_bottom_raster()

                jsr suca_wjazd_vic_setup

                jsr sprites_2014_setup

                ldx irq_counter
                lda zatrzesienie_d016,x
                sta $d016

                inc irq_counter
                lda irq_counter
                cmp #ZATRZESIENIE_D016_COUNT
                beq *+9

                ldx #<irq_welcome_14
                ldy #>irq_welcome_14
                lda #$00
                rts

                lda #$00
                sta irq_counter

                ldx #<irq_welcome_15
                ldy #>irq_welcome_15
                lda #$00
                rts
;-------------------------------
; IRQ bottom part ("SUCA") after stamping "2014" sign completed:
; .align $100
irq_stamp_2     ; .stabilize_raster_v2(RASTER_LINE_SOCI)

                .stabilize_bottom_raster()

                jsr suca_wjazd_vic_setup

                jsr sprites_2014_setup

                jsr sprites_2014_positions

                inc irq_counter
                lda irq_counter
                cmp #DELAY_BEFORE_COMPLETE_FADE_OUT
                beq *+9

                ldx #<irq_welcome_15
                ldy #>irq_welcome_15
                lda #$00
                rts

                lda #$00
                sta irq_counter

                ldx #<irq_end_part_1
                ldy #>irq_end_part_1
                lda #$00
                rts
;-------------------------------
sprites_2014_setup

                lda #SPRITE_0_SCREEN_VALUE
                sta SUCA_WJAZD_SCREEN_VIEW + $03f8 ; sprite 0 memory data
                sta WELCOME_TO_SCREEN_VIEW + $03f8 ; sprite 0 memory data
                lda #SPRITE_1_SCREEN_VALUE
                sta SUCA_WJAZD_SCREEN_VIEW + $03f9 ; sprite 1 memory data
                sta WELCOME_TO_SCREEN_VIEW + $03f9 ; sprite 1 memory data
                lda #SPRITE_2_SCREEN_VALUE
                sta SUCA_WJAZD_SCREEN_VIEW + $03fa ; sprite 2 memory data
                sta WELCOME_TO_SCREEN_VIEW + $03fa ; sprite 2 memory data
                lda #SPRITE_3_SCREEN_VALUE
                sta SUCA_WJAZD_SCREEN_VIEW + $03fb ; sprite 3 memory data
                sta WELCOME_TO_SCREEN_VIEW + $03fb ; sprite 3 memory data
                lda #SPRITE_4_SCREEN_VALUE
                sta SUCA_WJAZD_SCREEN_VIEW + $03fc ; sprite 4 memory data
                sta WELCOME_TO_SCREEN_VIEW + $03fc ; sprite 4 memory data
                lda #SPRITE_5_SCREEN_VALUE
                sta SUCA_WJAZD_SCREEN_VIEW + $03fd ; sprite 5 memory data
                sta WELCOME_TO_SCREEN_VIEW + $03fd ; sprite 5 memory data
                lda #$00
                sta $d01c   ; sprites multi-color mode select
                lda #$00
                sta $d017   ; expand sprites 2x vertical (Y)
                sta $d01d   ; expand sprites 2x horizontal (X)
                lda #$00
                sta $d01b   ; sprite is in front of the graphics
                lda #STAMP_2014_COLOUR
                sta $d027   ; sprite 0 color
                sta $d028   ; sprite 1 color
                sta $d029   ; sprite 2 color
                sta $d02a   ; sprite 3 color
                sta $d02b   ; sprite 4 color
                sta $d02c   ; sprite 5 color
                lda #$3f
                sta $d015   ; make them visible

                rts
;-------------------------------
sprites_2014_positions

                lda #((STAMP_2014_POSITION_X + $18 * $00) & $ff)
                sta $d000
                lda #(STAMP_2014_POSITION_Y + $15 * $00)
                sta $d001

                lda #((STAMP_2014_POSITION_X + $18 * $01) & $ff)
                sta $d002
                lda #(STAMP_2014_POSITION_Y + $15 * $00)
                sta $d003

                lda #((STAMP_2014_POSITION_X + $18 * $02) & $ff)
                sta $d004
                lda #(STAMP_2014_POSITION_Y + $15 * $00)
                sta $d005

                lda #((STAMP_2014_POSITION_X + $18 * $00) & $ff)
                sta $d006
                lda #(STAMP_2014_POSITION_Y + $15 * $01)
                sta $d007

                lda #((STAMP_2014_POSITION_X + $18 * $01) & $ff)
                sta $d008
                lda #(STAMP_2014_POSITION_Y + $15 * $01)
                sta $d009

                lda #((STAMP_2014_POSITION_X + $18 * $02) & $ff)
                sta $d00a
                lda #(STAMP_2014_POSITION_Y + $15 * $01)
                sta $d00b

                lda #%00111111
                sta $d010

                rts
;-------------------------------
sprites_2014_positions_stamped

                ldx irq_counter

                lda #((STAMP_2014_POSITION_X + $18 * $00) & $ff)
                clc
                adc zatrzesienie_d016,x
                sta $d000
                lda #(STAMP_2014_POSITION_Y + $15 * $00)
                sta $d001

                lda #((STAMP_2014_POSITION_X + $18 * $01) & $ff)
                clc
                adc zatrzesienie_d016,x
                sta $d002
                lda #(STAMP_2014_POSITION_Y + $15 * $00)
                sta $d003

                lda #((STAMP_2014_POSITION_X + $18 * $02) & $ff)
                clc
                adc zatrzesienie_d016,x
                sta $d004
                lda #(STAMP_2014_POSITION_Y + $15 * $00)
                sta $d005

                lda #((STAMP_2014_POSITION_X + $18 * $00) & $ff)
                clc
                adc zatrzesienie_d016,x
                sta $d006
                lda #(STAMP_2014_POSITION_Y + $15 * $01)
                sta $d007

                lda #((STAMP_2014_POSITION_X + $18 * $01) & $ff)
                clc
                adc zatrzesienie_d016,x
                sta $d008
                lda #(STAMP_2014_POSITION_Y + $15 * $01)
                sta $d009

                lda #((STAMP_2014_POSITION_X + $18 * $02) & $ff)
                clc
                adc zatrzesienie_d016,x
                sta $d00a
                lda #(STAMP_2014_POSITION_Y + $15 * $01)
                sta $d00b

                lda #%00111111
                sta $d010

                rts
;-------------------------------
