#!/usr/bin/perl

# scripts/calculate-exclamation-mark-sinus.pl

use utf8;
use bytes;
use strict;
use warnings;

local $| = 1;

use lib q{../../tools/lib};

use Data::Dumper;
# use Data::Transform qw(:all);
use Readonly;

use FindBin qw($Bin);
use lib $Bin;
use Helper qw(:all);

Readonly my $PI => 3.14;
Readonly my $NUM_VALUES => 0x40;
Readonly my $MAX_VALUE => 0x06;

# Calculate sinus values:
my $data = calculate_sinus_data();

# Print out generated lookup table:
my @data_split;
while (@{$data}) {
  push @data_split, [ splice @{$data}, 0x00, 0x08 ];
}
print_data_as_source_code(\@data_split);

sub calculate_sinus_data {
  my @data;
  for my $index (0x01 .. $NUM_VALUES) {
    my $sinus = int (cos ($PI * $index / $NUM_VALUES - $PI) * $MAX_VALUE + sin ($PI * $index / $NUM_VALUES - 1 / $NUM_VALUES * 2 * $PI) * $MAX_VALUE) + $MAX_VALUE;
    push @data, $sinus;
  }
  return \@data;
}
