;-------------------------------
; MEMORY ORGANISATION
; ===================
; $5400...$5800 - Welcome/to/HORNA screen view
; $5800...$6000 - Welcome/to/HORNA charset data
; $6000...$6400 - SUCA displayed screen view
; $6258...$6400 - SUCA screen data
; $6400...$6800 - SOCI displayed screen view
; $6658...$6800 - SOCI screen data
; $6800...$6d70 - SOCI/SUCA charset data
; $6d70...$6de8 - HORNA screen data
; $6e00...$6f80 - 2014 sprites data
; $6f80...$7100 - ? sprites data
; $7100...$7280 - ! sprites data
;-------------------------------

;-------------------------------
Z1            = $40;/$41
Z2            = $42;/$43
Z3            = $44;/$45
;-------------------------------

;-------------------------------
WELCOME_TO_START_ADDRESS = $3500
WELCOME_TO_LOADING_NEXT_PART_START_ADDRESS = $cf00
;-------------------------------
WELCOME_TO_SCREEN_VIEW   = $5400
WELCOME_TO_SCREEN_DATA   = $9000
WELCOME_TO_CHARSET_DATA  = $5800
HORNA_WJAZD_SCREEN_VIEW  = WELCOME_TO_SCREEN_VIEW + $28 * $0b
HORNA_WJAZD_SCREEN_DATA  = $6d70
HORNA_WJAZD_CHARSET_DATA = $5c00
HORNA_WJAZD_TARGET_FONTS = $5e00
;-------------------------------
WELCOME_TO_SCREEN_D018_CHARSET = ((WELCOME_TO_CHARSET_DATA & $3fff) >> 10)
WELCOME_TO_SCREEN_D018_SCREEN  = ((WELCOME_TO_SCREEN_VIEW & $3fff) >> 10 << 4)
WELCOME_TO_SCREEN_D018         = (WELCOME_TO_SCREEN_D018_CHARSET | WELCOME_TO_SCREEN_D018_SCREEN)
WELCOME_TO_SCREEN_DD00         = ((WELCOME_TO_CHARSET_DATA >> $0e)  ^ $03)
;-------------------------------
SOCI_WJAZD_SCREEN_VIEW       = $6400
SOCI_WJAZD_SCREEN_DATA       = SOCI_WJAZD_SCREEN_VIEW + $0258
SOCI_SUCA_WJAZD_CHARSET_DATA = $7800
SUCA_WJAZD_SCREEN_VIEW       = $6000
SUCA_WJAZD_SCREEN_DATA       = SUCA_WJAZD_SCREEN_VIEW + $0258
;-------------------------------
SOCI_WJAZD_SCREEN_D018_CHARSET = ((SOCI_SUCA_WJAZD_CHARSET_DATA & $3fff) >> 10)
SOCI_WJAZD_SCREEN_D018_SCREEN  = ((SOCI_WJAZD_SCREEN_VIEW & $3fff) >> 10 << 4)
SOCI_WJAZD_SCREEN_D018         = (SOCI_WJAZD_SCREEN_D018_CHARSET | SOCI_WJAZD_SCREEN_D018_SCREEN)
SOCI_WJAZD_SCREEN_DD00         = ((SOCI_SUCA_WJAZD_CHARSET_DATA >> $0e)  ^ $03)
;-------------------------------
SUCA_WJAZD_SCREEN_D018_CHARSET = ((SOCI_SUCA_WJAZD_CHARSET_DATA & $3fff) >> 10)
SUCA_WJAZD_SCREEN_D018_SCREEN  = ((SUCA_WJAZD_SCREEN_VIEW & $3fff) >> 10 << 4)
SUCA_WJAZD_SCREEN_D018         = (SUCA_WJAZD_SCREEN_D018_CHARSET | SUCA_WJAZD_SCREEN_D018_SCREEN)
SUCA_WJAZD_SCREEN_DD00         = ((SOCI_SUCA_WJAZD_CHARSET_DATA >> $0e)  ^ $03)
;-------------------------------
SPRITES_2014_DATA     = $6e00
SPRITE_0_SCREEN_VALUE = ((SPRITES_2014_DATA + $40 * $00) & $3fff) / $40
SPRITE_1_SCREEN_VALUE = ((SPRITES_2014_DATA + $40 * $01) & $3fff) / $40
SPRITE_2_SCREEN_VALUE = ((SPRITES_2014_DATA + $40 * $02) & $3fff) / $40
SPRITE_3_SCREEN_VALUE = ((SPRITES_2014_DATA + $40 * $03) & $3fff) / $40
SPRITE_4_SCREEN_VALUE = ((SPRITES_2014_DATA + $40 * $04) & $3fff) / $40
SPRITE_5_SCREEN_VALUE = ((SPRITES_2014_DATA + $40 * $05) & $3fff) / $40
;-------------------------------
SPRITES_QUESTION_MARK_DATA = $6f80
SPRITE_Q_0_SCREEN_VALUE    = ((SPRITES_QUESTION_MARK_DATA + $40 * $00) & $3fff) / $40
SPRITE_Q_1_SCREEN_VALUE    = ((SPRITES_QUESTION_MARK_DATA + $40 * $01) & $3fff) / $40
SPRITE_Q_2_SCREEN_VALUE    = ((SPRITES_QUESTION_MARK_DATA + $40 * $02) & $3fff) / $40
SPRITE_Q_3_SCREEN_VALUE    = ((SPRITES_QUESTION_MARK_DATA + $40 * $03) & $3fff) / $40
SPRITE_Q_4_SCREEN_VALUE    = ((SPRITES_QUESTION_MARK_DATA + $40 * $04) & $3fff) / $40
SPRITE_Q_5_SCREEN_VALUE    = ((SPRITES_QUESTION_MARK_DATA + $40 * $05) & $3fff) / $40
;-------------------------------
SPRITES_EXCLAMATION_MARK_DATA = $7100
SPRITE_E_0_SCREEN_VALUE    = ((SPRITES_EXCLAMATION_MARK_DATA + $40 * $00) & $3fff) / $40
SPRITE_E_1_SCREEN_VALUE    = ((SPRITES_EXCLAMATION_MARK_DATA + $40 * $01) & $3fff) / $40
SPRITE_E_2_SCREEN_VALUE    = ((SPRITES_EXCLAMATION_MARK_DATA + $40 * $02) & $3fff) / $40
SPRITE_E_3_SCREEN_VALUE    = ((SPRITES_EXCLAMATION_MARK_DATA + $40 * $03) & $3fff) / $40
SPRITE_E_4_SCREEN_VALUE    = ((SPRITES_EXCLAMATION_MARK_DATA + $40 * $04) & $3fff) / $40
SPRITE_E_5_SCREEN_VALUE    = ((SPRITES_EXCLAMATION_MARK_DATA + $40 * $05) & $3fff) / $40
;-------------------------------
; FREE: $7280 ... $FFFF
;-------------------------------

;-------------------------------
TEXT_COLOUR = $04
STAMP_2014_COLOUR = $02
STAMP_2014_POSITION_X = $08
STAMP_2014_POSITION_Y = $94
FALLING_SPRITE_START_POSITION_Y = $64
RISING_SPRITE_START_POSITION_Y = $b0
DELAY_BEFORE_WELCOME = $20
DELAY_BETWEEN_WELCOME_AND_TO = $38
DELAY_BETWEEN_SOCI_AND_QUESTION_MARK = $20
DELAY_BEFORE_QUESTION_MARK_DISAPPERS = $b0
DELAY_BETWEEN_SOCI_AND_SUCA = $20
DELAY_BEFORE_EXCLAMATION_MARK_APPEARS = $02
DELAY_BEFORE_EXCLAMATION_MARK_DISAPPEARS = $40
DELAY_BEFORE_HORNA_WJAZD = $08
DELAY_HORNA_WJAZD_COMPLETED = $18 * $04
DELAY_BEFORE_2014_STAMP = $20
DELAY_BEFORE_COMPLETE_FADE_OUT = $f0
RASTER_LINE_SOCI = $8c
RASTER_LINE_BETWEN_HORNA_AND_SOCI = $aa
;-------------------------------
