/** How to execute this script:
  *
  *   $ export AFTERIMAGE=/home/pkrol/.ivy2/cache/org.c64.attitude/afterimage/jars/afterimage-0.03-SNAPSHOT.jar
  *   $ export IMAGEJ=/home/pkrol/.ivy2/cache/gov.nih.imagej/imagej/jars/imagej-1.46.jar
  *   $ scala -classpath ${AFTERIMAGE}:${IMAGEJ} scripts/preview-fcp-pic.scala images/dummy-dream-logo.fcp
  */

import org.c64.attitude.Afterimage.Colour.Palette
import org.c64.attitude.Afterimage.File.File
import org.c64.attitude.Afterimage.View.Image

def usage() {
  println("  Usage: scripts/preview-fcp-pic.scala <IMAGE.FCP>")
}

val source = if (args.length > 0) args(0) else ""

if (source == "") {
  println("FacePainter file must be specified")
  usage()
  exit(1)
}

if (!new java.io.File(source).exists) {
  println("FacePainter file does not exist: \"%s\"".format(source))
  usage()
  exit(2)
}

val palette = Palette("default")

println("Generating image preview: \"%s\"".format(source))

val picture = File.load(source)
val image = Image(picture, palette)

image.show()
