#!/usr/bin/perl
#
# scripts/setup-pixel-line-offsets.pl

use utf8;
use bytes;
use strict;
use warnings;

local $| = 1;

use lib q{../../tools/lib};

use Data::Dumper;
use Readonly;

use FindBin qw($Bin);
use lib $Bin;
use Helper qw(:all);

my (@bitmap, @offset);

my $bitmap = 0x0000;

for (my $i = 0; $i < 200; $i++) {

  my $offset = $i & 0x07;
  $bitmap += 0x0140 unless $offset or $i == 0;

  push @bitmap, $bitmap;
  push @offset, $offset;
}

my (@bitmap_lo, @bitmap_hi);
while (@bitmap) {
  my @bitmap_chunk = splice @bitmap, 0x00, 0x08;
  push @bitmap_lo, [ map { sprintf '<$%04x', $_ } @bitmap_chunk ];
  push @bitmap_hi, [ map { sprintf '>$%04x', $_ } @bitmap_chunk ];
}

print get_data_as_source_code(\@bitmap_lo, 'BITMAP_SHIFT_LO', 1);
print "\n";
print get_data_as_source_code(\@bitmap_hi, 'BITMAP_SHIFT_HI', 1);
