;-------------------------------
; MEMORY ORGANISATION
; ===================
; BUFFER #1:
;   * $6000-$8000 - BITMAP #1
;   * $5C00-$6000 - SCREEN #1
; BUFFER #2:
;   * $A000-$C000 - BITMAP #2
;   * $8000-$8400 - SCREEN #2
; ALIAS MEDRON IMAGE DATA:
;   * $8400-$8BD0 - BITMAP
;   * $8BD0-$8CCA - SCREEN
;   * $8CCA-$8DC4 - COLORS
;-------------------------------

;-------------------------------
TWISTER_START_ADDRESS = $3000
TWISTER_LOADING_NEXT_PART_START_ADDRESS = $c000
;-------------------------------
BITMAP_1          = $6000
SCREEN_1          = $5c00
;-------------------------------
BITMAP_2          = $a000
SCREEN_2          = $8000
;-------------------------------
; FREE: $3000 ... $5C00
; FREE: $C000 ... $FFFF
;-------------------------------

;-------------------------------
BACKGROUND_COLOUR = $0c
LAST_PIXEL_ROW    = $c7
;-------------------------------
DELAY_BEFORE_SHOWING_LOGO         = $02
DELAY_BEFORE_SHOWING_TWISTER      = $08
DELAY_BEFORE_FIRST_COLOUR_CHANGE  = $a0
DELAY_AFTER_FIRST_COLOUR_CHANGE   = $10
DELAY_BEFORE_SECOND_COLOUR_CHANGE = $a0
DELAY_AFTER_SECOND_COLOUR_CHANGE  = $10
DELAY_BEFORE_THIRD_COLOUR_CHANGE  = $a0
DELAY_AFTER_THIRD_COLOUR_CHANGE   = $10
;-------------------------------

;-------------------------------
; Twister specific variables:
;-------------------------------
VAR_SOURCE_SCREEN_DATA  = Z1
VAR_TARGET_SCREEN_DATA  = Z2
VAR_SCREEN_LINE_INDEX   = Z3 + $00
VAR_TWISTER_STEP_INDEX  = Z3 + $01
MAX_SCREEN_LINES        = $19
NUM_AVAILABLE_INDEXES_1 = twister_data_index_hi - twister_data_index_lo
NUM_AVAILABLE_INDEXES_2 = twister_data_2_index_hi - twister_data_2_index_lo
NUM_AVAILABLE_INDEXES_3 = twister_data_3_index_hi - twister_data_3_index_lo
NUM_SCREEN_VALUES       = twister_data_index_02 - twister_data_index_01
;-------------------------------

;-------------------------------
EMPTY_CHAR           = (BACKGROUND_COLOUR << 4) | BACKGROUND_COLOUR
;-------------------------------
SCREEN_1_D018_BITMAP = ((BITMAP_1 & $3fff) >> 10)
SCREEN_1_D018_SCREEN = ((SCREEN_1 & $3fff) >> 10 << 4)
SCREEN_1_D018        = (SCREEN_1_D018_BITMAP | SCREEN_1_D018_SCREEN)
SCREEN_1_DD00        = ((BITMAP_1 >> 14)  ^ $03)
;-------------------------------
SCREEN_2_D018_BITMAP = ((BITMAP_2 & $3fff) >> 10)
SCREEN_2_D018_SCREEN = ((SCREEN_2 & $3fff) >> 10 << 4)
SCREEN_2_D018        = (SCREEN_2_D018_BITMAP | SCREEN_2_D018_SCREEN)
SCREEN_2_DD00        = ((BITMAP_2 >> 14)  ^ $03)
;-------------------------------
ALIAS_MEDRON_BITMAP  = $8400
ALIAS_MEDRON_SCREEN  = ALIAS_MEDRON_BITMAP + ALIAS_MEDRON_NUM_ROWS * ALIAS_MEDRON_NUM_COLS * $08
ALIAS_MEDRON_COLORS  = ALIAS_MEDRON_SCREEN + ALIAS_MEDRON_NUM_ROWS * ALIAS_MEDRON_NUM_COLS * $01
;-------------------------------
BITMAP_SHIFT_LO      = ALIAS_MEDRON_COLORS + ALIAS_MEDRON_NUM_ROWS * ALIAS_MEDRON_NUM_COLS * $01
BITMAP_SHIFT_HI      = BITMAP_SHIFT_LO + ALIAS_MEDRON_NUM_ROWS * $08
;-------------------------------
ALIAS_MEDRON_BITMAP_HI = BITMAP_SHIFT_HI + ALIAS_MEDRON_NUM_ROWS * $08
ALIAS_MEDRON_BITMAP_LO = ALIAS_MEDRON_BITMAP_HI + ALIAS_MEDRON_NUM_ROWS * $08
;-------------------------------
TWISTER_INDEX_DATA   = ALIAS_MEDRON_BITMAP_LO + ALIAS_MEDRON_NUM_ROWS * $08
;-------------------------------

;-------------------------------
Z1            = $40;/$41
Z2            = $42;/$43
Z3            = $44;/$45
Z4            = $46;/$47
Z5            = $48;/$49
;-------------------------------
