;-------------------------------
#macro add_number_to_zeropage_variable(number,zervar)
{
                ; 11 bytes in total
                clc
                lda {zervar} + $00
                adc #{number}
                sta {zervar} + $00
                bcc *+4
                inc {zervar} + $01
}
;-------------------------------
#macro wait_for_spacebar()
{
                lda #$ff
                sta $dc02
                lda #$00
                sta $dc03
                lda #$7f
                sta $dc00
                lda $dc01
                cmp #$ef
                bne *-20

                inc $d020

                lda #$ff
                sta $dc02
                lda #$00
                sta $dc03
                lda #$7f
                sta $dc00
                lda $dc01
                cmp #$ef
                beq *-20

                dec $d020
}
;-------------------------------
#macro stabilize_raster(suffix)
{
                ; Setup wedge IRQ vector:
                lda #<almost_stable_raster_{suffix}
                sta $fffe
                lda #>almost_stable_raster_{suffix}
                sta $ffff
                ; Set the raster IRQ to trigger on the next raster line:
                inc $d012
                ; Acknowlege current raster IRQ:
                lda #$01
                sta $d019
                ; Store current stack pointer (will be messed up when the next IRQ occurs):
                tsx
                ; Allow IRQ to happen (remember the interrupt flag is set by the interrupt handler):
                cli
                ; Execute NOPs untill the raster line changes and the raster IRQ triggers:
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
almost_stable_raster_{suffix}
                ; Restore previous stack pointer (ignore the last stack manipulation by the IRQ):
                txs
                ; At this point the next raster compare IRQ has triggered and the jitter is max 1 cycle:
                ldy #$08
                dey
                bne *-1
                bit $ea
                ; Check if $d012 is incremented and rectify with an aditional cycle if neccessary:
                lda $d012
                cmp $d012  ; <- critical instruction (ZERO-flag will indicate if jitter = 0 or 1)
                ; Add one cycle if $d012 wasn't incremented (jitter / ZERO-flag = 0):
                beq *+2
                ; STABLE CODE!!!
                ldx #$07
                dex
                bne *-1
                nop
                nop
}
;-------------------------------
