#!/usr/bin/perl
#
# scripts/convert-presents-image-to-fonts.pl

use utf8;
use bytes;
use strict;
use warnings;

local $| = 1;

use lib q{../../tools/lib};

use FindBin qw($Bin);
use lib $Bin;
use Helper qw(:all);

use Data::Dumper;
use Data::Transform qw(:all);
use Graphics::Builder;
use Graphics::Transform qw(:all);
use Readonly;

Readonly our $picture => sprintf '%s/../images/presents.png', $Bin;

my $image = Graphics::Builder->new_from(png_file => $picture);
my $data = $image->to_hires_bitmap();

my ($fonts, $screen_map) = convert_plain_bitmap_to_fonts(
  data => $data,
  rows => 25,
  cols => 40,
);

my @printable_fonts = map { [ map { '$' . unpack 'H*', chr } convert_binary_data_to_hex_values(data => $_) ] } @{$fonts};
my @printable_screen_map = map { [ map { '$' . unpack 'H*', chr } convert_binary_data_to_hex_values(data => $_) ] } @{$screen_map};

print get_data_as_source_code(\@printable_fonts, 'PRESENTS_CHARSET', 1);
print "\n";
print get_data_as_source_code(\@printable_screen_map, 'PRESENTS_SCREEN', 1);
