#!/usr/bin/perl
#
# scripts/setup-bitmap-data-lookup-table.pl

use utf8;
use bytes;
use strict;
use warnings;

local $| = 1;

use lib q{../../tools/lib};

use FindBin qw($Bin);
use lib $Bin;
use Helper qw(:all);

use Data::Dumper;

my $bitmap_varname = 'HOMUNCULI_SOURCE_BITMAP';

my $bitmap = 0x0000;

my @offsets;

for (my $y = 0; $y < 200; $y++) {

  my $offset = ($y >> 0x03) * 0x0140 + ($y & 0x07);

  push @offsets, $offset;
}

my @bitmap_offsets_lo = map { [ sprintf '<(HOMUNCULI_SOURCE_BITMAP + $%04x)', $_ ] } @offsets;
my @source_offsets_hi = map { [ sprintf '>(HOMUNCULI_SOURCE_BITMAP + $%04x)', $_ ] } @offsets;
my @target_offsets_hi = map { [ sprintf '>(HOMUNCULI_TARGET_BITMAP + $%04x)', $_ ] } @offsets;

print get_data_as_source_code(\@bitmap_offsets_lo, 'HOMUNCULI_BITMAP_OFFSET_Y_LO', 1);
print "\n";
print get_data_as_source_code(\@source_offsets_hi, 'HOMUNCULI_SOURCE_BITMAP_Y_HI', 1);
print "\n";
print get_data_as_source_code(\@target_offsets_hi, 'HOMUNCULI_TARGET_BITMAP_Y_HI', 1);
