;---------------------------------
; MEMORY ORGANISATION
; ===================
; SOURCE CODE:
;   * $8800-$8D00 - CODE
;   * $8D00-$9000 - PRESENTS (DATA)
;   * $9000-$A700 - HOMUNCULI (DATA)
;   * $A700-$AA00 - LOOKUP TABLES (SOURCE/TARGET BITMAP)
; PRESENTS PICTURE:
;   * $5000-$5800 - CHARSET
;   * $5800-$5c00 - SCREEN
; HOMUNCULI PICTURE:
;   * $4000-$6000 - TARGET BITMAP
;   * $6000-$6400 - SCREEN
;   * $6400-$6800 - COLORS
;   * $6800-$8800 - SOURCE BITMAP
;---------------------------------

;---------------------------------
TITLE_SCREEN_START_ADDRESS = $8800
TITLE_SCREEN_NEXT_PART_START_ADDRESS = $3e00
;---------------------------------
PRESENTS_COMPRESSED_DATA   = $8d00
PRESENTS_CHARSET           = $5000
PRESENTS_SCREEN            = $5800
;---------------------------------
HOMUNCULI_COMPRESSED_DATA  = $9000
HOMUNCULI_SOURCE_BITMAP    = $6800
HOMUNCULI_TARGET_BITMAP    = $4000
HOMUNCULI_SCREEN           = $6000
HOMUNCULI_COLORS           = $6400
;---------------------------------
HOMUNCULI_BITMAP_OFFSET_Y_LO = $A700
HOMUNCULI_SOURCE_BITMAP_Y_HI = $A800
HOMUNCULI_TARGET_BITMAP_Y_HI = $A900
;---------------------------------

;---------------------------------
BACKGROUND_COLOUR    = $0c
PRESENTS_COLOUR      = $0b
;---------------------------------
PRESENTS_BLINKING_TIME            = $60
PRESENTS_VISIBILITY_TIME          = $50
DELAY_BEFORE_SHOWING_TITLE_SCREEN = $20
HOMUNCULI_SHOWING_TIME            = $64
HOMUNCULI_VISIBILITY_TIME         = $f0
;---------------------------------

;---------------------------------
PRESENTS_D018_CHARSET = ((PRESENTS_CHARSET & $3fff) >> 10)
PRESENTS_D018_SCREEN  = ((PRESENTS_SCREEN & $3fff) >> 10 << 4)
PRESENTS_D018         = (PRESENTS_D018_CHARSET | PRESENTS_D018_SCREEN)
PRESENTS_DD00         = ((PRESENTS_CHARSET >> 14)  ^ $03)
;---------------------------------
HOMUNCULI_D018_BITMAP = ((HOMUNCULI_TARGET_BITMAP & $3fff) >> 10)
HOMUNCULI_D018_SCREEN = ((HOMUNCULI_SCREEN & $3fff) >> 10 << 4)
HOMUNCULI_D018        = (HOMUNCULI_D018_BITMAP | HOMUNCULI_D018_SCREEN)
HOMUNCULI_DD00        = ((HOMUNCULI_TARGET_BITMAP >> 14)  ^ $03)
;---------------------------------

;---------------------------------
Z1            = $40;/$41
Z2            = $42;/$43
Z3            = $44;/$45
Z4            = $46;/$47
;---------------------------------
