;-------------------------------
; MEMORY ORGANISATION
; ===================
; SOURCE CODE:
;   * $7C00-$.... - CODE
;   * $C200-$.... - CODE
; BUFFER #1:
;   * $6800-$7000 - CHARSET #1
;   * $6400-$6800 - SCREEN #1
; BUFFER #2:
;   * $7000-$7800 - CHARSET #2
;   * $7800-$7c00 - SCREEN #2
; MULTICOLOUR PICTURE:
;   * $4000-$6000 - BITMAP
;   * $6000-$6400 - SCREEN
;   * $7C00-$8000 - COLORS
; VECTOR 1 DATA:
;   * $9400-$C200 - DATA
;-------------------------------

;-------------------------------
VECTOR1_START_ADDRESS = $8000
VECTOR1_NEXT_PART_START_ADDRESS = $c200
;-------------------------------
VECTOR_DISPLAY_NUM_ROWS = $08
VECTOR_SCROLL_NUM_FRAMES = $40
;-------------------------------
BITMAP            = $4000
SCREEN            = $6000
COLORS            = $7c00
CELTIC_BITMAP     = BITMAP + VECTOR_DISPLAY_NUM_ROWS * $0140
CELTIC_SCREEN     = SCREEN + VECTOR_DISPLAY_NUM_ROWS * $0028
CELTIC_COLORS     = COLORS + VECTOR_DISPLAY_NUM_ROWS * $0028
;-------------------------------
CHARSET_1         = $6800
CHARSET_OUTLINE_1 = CHARSET_1 + $0000 ; CHARSET_1 + $0200
CHARSET_FILLED_1  = CHARSET_1 + $0000
SCREEN_1          = $6400
;-------------------------------
CHARSET_2         = $7000
CHARSET_OUTLINE_2 = CHARSET_2 + $0000 ; CHARSET_2 + $0200
CHARSET_FILLED_2  = CHARSET_2 + $0000
SCREEN_2          = $7800
;-------------------------------
AVE_SATAN_SCREEN_DATA  = $9400
AVE_SATAN_CHARSET_DATA = AVE_SATAN_SCREEN_DATA + AVE_SATAN_NUM_ROWS * $28
;-------------------------------
VECTOR_SCROLL_POSITIONS       = AVE_SATAN_CHARSET_DATA + AVE_SATAN_NUM_FONTS * $08
VECTOR_SCROLL_D016_OFFSETS    = VECTOR_SCROLL_POSITIONS + VECTOR_SCROLL_NUM_FRAMES
VECTOR_OUTSCROLL_POSITIONS    = VECTOR_SCROLL_D016_OFFSETS + VECTOR_SCROLL_NUM_FRAMES
VECTOR_OUTSCROLL_D016_OFFSETS = VECTOR_OUTSCROLL_POSITIONS + VECTOR_SCROLL_NUM_FRAMES
VECTOR_OUTSCROLL_VISIBLE_COLS = VECTOR_OUTSCROLL_D016_OFFSETS + VECTOR_SCROLL_NUM_FRAMES
;-------------------------------
VECTOR_1          = VECTOR_OUTSCROLL_VISIBLE_COLS + VECTOR_SCROLL_NUM_FRAMES
;-------------------------------
; FREE: $3000 ... $4000
; FREE: $D000 ... $FFFF
;-------------------------------

;-------------------------------
BACKGROUND_COLOUR    = $00
AVE_SATAN_NUM_ROWS   = $05
AVE_SATAN_NUM_FONTS  = $65
RASTER_SWITCH_LINE   = $5c
RASTER_SWITCH_LINE_2 = $72
CELTIC_GFX_NUM_ROWS  = $19 - VECTOR_DISPLAY_NUM_ROWS
INITIAL_FLD_VALUE    = $80
SCROLL_NUM_FRAMES    = $40
;-------------------------------
DELAY_AFTER_1SZY_BLYSK_SZATANA = $40
DELAY_BEFORE_1SZY_ZNIK_SZATANA = $40
DELAY_AFTER_1SZY_ZNIK_SZATANA  = $20
DELAY_BEFORE_2GI_BLYSK_SZATANA = $40
DELAY_BEFORE_2GI_2GI_BLYSK_SZATANA = $60
DELAY_AFTER_2GI_BLYSK_SZATANA  = $c0
DELAY_AFTER_2GI_ZNIK_SZATANA   = $00
;-------------------------------
; Jak dlugo widoczny jest wektor na srodku ekranu:
DELAY_BEFORE_ODJAZD_WEKTORA = $a0
;-------------------------------

;-------------------------------
; Vector specific variables:
;-------------------------------
EMPTY_CHAR = $80
VECTOR_NUM_COLS = $08
VECTOR_NUM_ROWS = $08
COLOR_1 = $06
COLOR_2 = $02
COLOR_3 = $05
;-------------------------------

;-------------------------------
SCREEN_1_D018_CHARSET = ((CHARSET_1 & $3fff) >> 10)
SCREEN_1_D018_SCREEN  = ((SCREEN_1 & $3fff) >> 10 << 4)
SCREEN_1_D018         = (SCREEN_1_D018_CHARSET | SCREEN_1_D018_SCREEN)
SCREEN_1_DD00         = ((CHARSET_1 >> 14)  ^ $03)
;-------------------------------
SCREEN_2_D018_CHARSET = ((CHARSET_2 & $3fff) >> 10)
SCREEN_2_D018_SCREEN  = ((SCREEN_2 & $3fff) >> 10 << 4)
SCREEN_2_D018         = (SCREEN_2_D018_CHARSET | SCREEN_2_D018_SCREEN)
SCREEN_2_DD00         = ((CHARSET_2 >> 14)  ^ $03)
;-------------------------------
SCREEN_3_D018_CHARSET = ((BITMAP & $3fff) >> 10)
SCREEN_3_D018_SCREEN  = ((SCREEN & $3fff) >> 10 << 4)
SCREEN_3_D018         = (SCREEN_3_D018_CHARSET | SCREEN_3_D018_SCREEN)
SCREEN_3_DD00         = ((BITMAP >> 14)  ^ $03)
;-------------------------------

;-------------------------------
Z1            = $40;/$41
Z2            = $42;/$43
Z3            = $44;/$45
Z4            = $46;/$47
VECTOR_DATA   = $48;/$49
VECTOR_FRAME  = $4a
VECTOR_INDEX  = $4b
;-------------------------------
X1            = $50
Y1            = $51
X2            = $52
Y2            = $53
;-------------------------------
deltaerr      = $54
error         = $55
deltax        = $56
deltay        = $57
;-------------------------------
