#!/usr/bin/perl

use strict;
use warnings;

my @groups = grep { chomp } <DATA>;

my $all;
for my $group (@groups) {
  (my $group_with_underscores = $group) =~ tr/ /_/;
  $all .= qq{             .db <greet_${group_with_underscores}\n};
}

print_comment();

$all =~ s/^.{12}/greetings_lo/;
print $all;

print_comment();

$all =~ s/^.{12}/greetings_hi/;
$all =~ tr/</>/;
print $all;

print_comment();

print qq{\n};

print_comment();

for my $group (@groups) {
  (my $group_with_underscores = $group) =~ tr/ /_/;
  my $one = sprintf qq{greet_%-15s .ds "${group}"\n                      .db \$ff,*-greet_${group_with_underscores}\n}, $group_with_underscores;
  print $one;
  print_comment();
}

print qq{\n};

srand(456);

my (@greetings_x, @greetings_y);

for my $group (@groups) {
  push @greetings_x, int(rand(40 - length ($group) * 3));
  push @greetings_y, int(rand(23));
}

my $greetings_x = join ',', map { sprintf '$%02x', $_ } @greetings_x;
my $greetings_y = join ',', map { sprintf '$%02x', $_ } @greetings_y;

print_comment();
print qq{show_group_position_x .db $greetings_x\n};
print_comment();
print qq{show_group_position_y .db $greetings_y\n};
print_comment();

sub print_comment {
  print qq{;-------------------------------\n};
}

__END__
agenda
albion
arise
arsenic
avatar
black sun
blowjobb
booze design
camelot
chorus
darklite
dekadence
dmagic
elysium
excess
extend
fairlight
fatum
gemba boys
glance
gp
grayscale
hooy program
lepsi
mystic bytes
nostalgia
offence
onslaught
oxyron
panda design
plush
protovision
resource
samar
shape
singular
ssg
triad
tristesse
tropyx
vulture
wrath designs
