#!/usr/bin/perl
#
# scripts/prepare-the-end-bitmap.pl images/the-end.png target/the-end.dat

use utf8;
use bytes;
use strict;
use warnings;

local $| = 1;

use lib q{../../tools/lib};

use Graphics::Builder;
use IO::File;

my ($source, $target) = @ARGV;

# Build image builder object from a PNG file:
my $image = Graphics::Builder->new_from(png_file => $source);

# Get 8000 raw hires bitmap data bytes without screen colours (ready to save to a disk file):
my $bytes = $image->to_hires_bitmap();

my $fh = IO::File->new("> $target");
die qq{Failed to write file: "$target"} unless defined $fh;

$fh->binmode(':bytes');
print $fh $bytes;
$fh->close;
