;-------------------------------
; This helper file is required in fade-out-basic.src, because at
; a time of a BASIC fade-out framework code is not yet available
;-------------------------------
setup           ; Setup IRQ:
                sei
                lda #$35
                sta $01
                lda #<irq_return
                sta $fffa
                sta $fffc
                lda #>irq_return
                sta $fffb
                sta $fffd
                lda #<irq_enter
                sta $fffe
                lda #>irq_enter
                sta $ffff
                lda #<irq_soft_enter
                sta $0314
                lda #>irq_soft_enter
                sta $0315
                lda #$7f
                sta $dc0d
                lda $d011
                and #$7f
                sta $d011
                lda #$00
                sta $d012
                sta $dc0e
                lda #$01
                sta $d01a
                sta $d019
                ldx #<irq_default
                ldy #>irq_default
                stx irq_routine_lo
                sty irq_routine_hi

                ; Setup music:
                lda #$00
                tax
                tay
                jsr $1000

                rts
;-------------------------------
irq_enter       pha
                txa
                pha
                tya
                pha
                lda $01
                pha
                lda #$35
                sta $01
                jsr irq_routine
                stx irq_routine_lo
                sty irq_routine_hi
                sta $d012
                lda #<irq_enter
                sta $fffe
                lda #>irq_enter
                sta $ffff
                inc $d019
                lda $dc0d
                pla
                sta $01
                pla
                tay
                pla
                tax
                pla
irq_return      rti
;-------------------------------
irq_soft_enter  jsr irq_routine
                stx irq_routine_lo
                sty irq_routine_hi
                sta $d012
                inc $d019
                jmp $ea7e
;-------------------------------
irq_routine
irq_routine_lo  = *+1
irq_routine_hi  = *+2
                jmp *
;-------------------------------
irq_default     jsr _msx_play_exec

                lda #$00
                ldx #<irq_default
                ldy #>irq_default
                rts
;-------------------------------
irq_vic_setup   lda $dd00
                and #$fc
                ora #$03
                sta $dd00
                lda #$14
                sta $d018
                lda #$08
                sta $d016
                lda #$1b
                sta $d011
                rts
;-------------------------------
_msx_play_exec  jsr $1003
                ; Increment synchronisation counter SYNCHRO_COUNTER:
                inc SYNCHRO_COUNTER + 0
                bne *+4
                inc SYNCHRO_COUNTER + 1
                rts
;-------------------------------
_raster_wait    bit $d012
                bmi *+7
                bit $d012
                bpl *-3
                bit $d012
                bmi *-3
                rts
;-------------------------------
