#!/usr/bin/perl

use utf8;
use bytes;
use strict;
use warnings;

local $| = 1;

use lib q{../../../tools/lib};

use Data::Dumper;
use List::Util qw(shuffle);
use Source::Data qw(generate_source_data);

my @positions;
for my $x (0x00 .. 0x07) {
  for my $y (0x00 .. 0x04) {
    push @positions, { 'x' => $x, 'y' => $y };
  }
}
for (0x00 .. 0xff) {
  @positions = shuffle @positions;
}

my @positions_x = map { $_->{'x'} } @positions;
my @positions_y = map { $_->{'y'} } @positions;

my $positions_x_source = generate_source_data(
  calculate_hex_values => 1,
  data                 => \@positions_x,
  expected_indentation => 19,
  include_comments     => 1,
  name                 => 'sprite_positions_x',
  values_per_line      => 8,
);

my $positions_y_source = generate_source_data(
  calculate_hex_values => 1,
  data                 => \@positions_y,
  expected_indentation => 19,
  name                 => 'sprite_positions_y',
  values_per_line      => 8,
);

print $positions_x_source;
print $positions_y_source;
