package Graphics::BaseImage;

use utf8;
use bytes;
use strict;
use warnings;

use IO::File;
use File::stat;

sub _fetch_data {
  my ($self, %args) = @_;
  my $data = $args{data};
  my $file = $args{file};
  if (defined $file) {
    my $bytes = $self->_load($file);
    return $bytes;
  }
  if (defined $data) {
    return $data;
  }
  return;
}

sub _load {
  my ($self, $file) = @_;
  my $filesize = stat($file)->size;
  my $data;
  my $fh = new IO::File $file, 'r';
  if (defined $fh) {
    $fh->binmode(':bytes');
    sysread $fh, $data, $filesize;
    $fh->close;
  }
  return $data;
}

sub _set_bitmap_data {
  my ($self, $data) = @_;
  $self->{bitmap} = $data;
  return;
}

sub _set_screen_data {
  my ($self, $data) = @_;
  $self->{screen} = $data;
  return;
}

sub _set_colors_data {
  my ($self, $data) = @_;
  $self->{colors} = $data;
  return;
}

sub _set_bckgrd_data {
  my ($self, $data) = @_;
  $self->{bckgrd} = $data;
  return;
}

sub _set_border_data {
  my ($self, $data) = @_;
  $self->{border} = $data;
  return;
}

sub _get_bitmap_data {
  my ($self) = @_;
  my $data = $self->{bitmap};
  return $data;
}

sub _get_screen_data {
  my ($self) = @_;
  my $data = $self->{screen};
  return $data;
}

sub _get_colors_data {
  my ($self) = @_;
  my $data = $self->{colors};
  return $data;
}

sub _get_bckgrd_data {
  my ($self) = @_;
  my $data = $self->{bckgrd};
  return $data;
}

sub _get_border_data {
  my ($self) = @_;
  my $data = $self->{border};
  return $data;
}

sub fetch_bitmap_data {
  my ($self, %args) = @_;
  my $rawdata = $args{rawdata};
  die 'Not implemented';
}

sub fetch_screen_data {
  my ($self, %args) = @_;
  my $rawdata = $args{rawdata};
  die 'Not implemented';
}

sub fetch_colors_data {
  my ($self, %args) = @_;
  my $rawdata = $args{rawdata};
  die 'Not implemented';
}

sub fetch_bckgrd_data {
  my ($self, %args) = @_;
  my $rawdata = $args{rawdata};
  die 'Not implemented';
}

sub fetch_border_data {
  my ($self, %args) = @_;
  my $rawdata = $args{rawdata};
  die 'Not implemented';
}

1;
