package Graphics::FacePainter;

=head1 NAME

Graphics::FacePainter - Handling FacePainter image format operations

=head1 SYNOPSIS

  use Graphics::FacePainter;

  my $picture = Graphics::FacePainter->new(file => 'frighthof83-yazoo.fcp');

=cut

use bytes;
use strict;
use utf8;
use warnings;

use parent qw(Graphics::MultiColour);

use Data::Dumper;

sub new {
  my ($this, %args) = @_;
  my $class = ref $this || $this;
  my $self = $class->SUPER::new(%args);
  bless $self, $class;
  $self->_initialize(%args);
  return $self;
}

sub fetch_bitmap_data {
  my ($self, %args) = @_;
  my $rawdata = $args{rawdata};
  my $data = substr $rawdata, 0x0002, 0x1f40;
  return $data;
}

sub fetch_screen_data {
  my ($self, %args) = @_;
  my $rawdata = $args{rawdata};
  my $data = substr $rawdata, 0x1f42, 0x03e8;
  return $data;
}

sub fetch_colors_data {
  my ($self, %args) = @_;
  my $rawdata = $args{rawdata};
  my $data = substr $rawdata, 0x232a, 0x03e8;
  return $data;
}

sub fetch_bckgrd_data {
  my ($self, %args) = @_;
  my $rawdata = $args{rawdata};
  my $data = substr $rawdata, 0x2713, 0x0001;
  return $data;
}

sub fetch_border_data {
  my ($self, %args) = @_;
  my $rawdata = $args{rawdata};
  my $data = substr $rawdata, 0x2712, 0x0001;
  return $data;
}

1;

__END__