#!/usr/bin/perl
#
# Example:
#
#   $ tools/scripts/make-empty-d64.pl --filename=<FILENAME.D64>

use bytes;
use strict;
use warnings;

use lib q{tools/lib};

use Carp qw(croak);
use Getopt::Long;

use D64::Procedures qw(create_disk);

my $filename;

my $result = GetOptions(
    q{filename=s} => \$filename,
);

help() unless defined $filename;

croak qq{File "${filename}" already exists} if -e $filename;

create_disk($filename);

print qq{\nDone.\n\n};

sub help {
    print <<HELP;

Usage: $0 --filename=<FILENAME.D64>

Creates an empty FILENAME.D64 disk image.

(C) 2012-10-08 DJ Gruby/Arsenic/Oxyron

HELP
    exit 1;
}

1;

__END__